﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace WindowsFormsApplication62
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_AfterRowLayoutItemResized(object sender, Infragistics.Win.UltraWinGrid.AfterRowLayoutItemResizedEventArgs e)
        {
            Debug.Write("AfterRowLayoutItemResized: ");

            if (e.RowLayoutItem is UltraGridColumn)
            {
                // If the RowLayoutItem is an instance of UltraGridColumn, then cells associated
                // with that column are being resized.
                UltraGridColumn column = (UltraGridColumn)e.RowLayoutItem;

                Debug.Write("Cell in row-layout resized. Column = " + column.Header.Caption);
            }
            else
            {
                // If the RowLayoutItem is an instance of HeaderBase, then column header (also 
                // referred to as column label) is being resized.
                HeaderBase header = (HeaderBase)e.RowLayoutItem;

                Debug.Write("Header in row-layout resized. Header = " + header.Caption);
            }

            Debug.WriteLine(" New Size = " + e.RowLayoutItem.PreferredSize);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // Original code by Boris
            // e.Layout.Bands[0].RowLayoutStyle = Infragistics.Win.UltraWinGrid.RowLayoutStyle.GroupLayout;

            // Modified code by Paul Holliday
            UltraGridBand band = this.ultraGrid1.DisplayLayout.Bands[0];

            band.Groups.Clear();

            band.ColHeadersVisible = false;
            band.Override.RowSizing = RowSizing.Fixed;
            band.RowLayoutStyle = RowLayoutStyle.GroupLayout;

            // Add main headers
            UltraGridGroup aZero = band.Groups.Add("aZero", "Zero");
            UltraGridGroup aOne = band.Groups.Add("aOneTwoThree", "One to Three");
            UltraGridGroup aFour = band.Groups.Add("aFour", "Four");

            // Add number headers
            UltraGridGroup bZero = band.Groups.Add("bZero", "0");
            UltraGridGroup bOne = band.Groups.Add("bOne", "1");
            UltraGridGroup bTwo = band.Groups.Add("bTwo", "2");
            UltraGridGroup bThree = band.Groups.Add("bThree", "3");
            UltraGridGroup bFour = band.Groups.Add("bFour", "4");

            aZero.RowLayoutGroupInfo.PreferredLabelSize = new Size(1, 20);
            bZero.RowLayoutGroupInfo.PreferredLabelSize = new Size(1, 20);

            // Assign number headers to main headers
            bZero.RowLayoutGroupInfo.ParentGroup = aZero;
            bOne.RowLayoutGroupInfo.ParentGroup = aOne;
            bTwo.RowLayoutGroupInfo.ParentGroup = aOne;
            bThree.RowLayoutGroupInfo.ParentGroup = aOne;
            bFour.RowLayoutGroupInfo.ParentGroup = aFour;

            // Optionally display description headers
            Infragistics.Win.Appearance a = new Infragistics.Win.Appearance();
            a.FontData.SizeInPoints = 8.25f;

            // Add description headers
            UltraGridGroup cZero = band.Groups.Add("cZero", "Nothing");
            UltraGridGroup cOne = band.Groups.Add("cOne", "The first" + Environment.NewLine + "numbered column");
            UltraGridGroup cTwo = band.Groups.Add("cTwo", "Second" + Environment.NewLine + "column here");
            UltraGridGroup cThree = band.Groups.Add("cThree", "Third column" + Environment.NewLine + "has three" + Environment.NewLine + "line");
            UltraGridGroup cFour = band.Groups.Add("cFour", "Fourth and" + Environment.NewLine + "final here");

            // Set Appearance
            cZero.Header.Appearance = a;
            cOne.Header.Appearance = a;
            cTwo.Header.Appearance = a;
            cThree.Header.Appearance = a;
            cFour.Header.Appearance = a;

            // Assign description headers to number headers
            cZero.RowLayoutGroupInfo.ParentGroup = bZero;
            cOne.RowLayoutGroupInfo.ParentGroup = bOne;
            cTwo.RowLayoutGroupInfo.ParentGroup = bTwo;
            cThree.RowLayoutGroupInfo.ParentGroup = bThree;
            cFour.RowLayoutGroupInfo.ParentGroup = bFour;

            // Set Row Height
            cZero.RowLayoutGroupInfo.PreferredLabelSize = new Size(1, 68);

            band.Columns["Column 0"].RowLayoutColumnInfo.ParentGroup = cZero;
            band.Columns["Column 1"].RowLayoutColumnInfo.ParentGroup = cOne;
            band.Columns["Column 2"].RowLayoutColumnInfo.ParentGroup = cTwo;
            band.Columns["Column 3"].RowLayoutColumnInfo.ParentGroup = cThree;
            band.Columns["Column 4"].RowLayoutColumnInfo.ParentGroup = cFour;
        }

    }
}
